%clc; clear; format long
%addpath( genpath( 'library' ) , genpath( './geneticTesting' ) , '-begin' ) ;
clc ; close('all') ; clear; format long ; 
restoredefaultpath( )                        ;
addpath( genpath( '../library' ) , '-begin' ) ;

R        = 8.3144598 ;                                     % [J/mol/K]
% Define components
% ------------------------------------ He , Helium (NIST)
MMhel    = 4.002602;                                       % [g/mol] He
Tchel    = 5.1953  ;                                       % [K]
Pchel    = 2.2746  ;                                       % [bar] 
whel     = -0.382  ;                                       % [] Pitzer
Tbhel    = 4.230   ;                                       % [K] Normal BP
% ------------------------------------ N2 , Nitrogen (NIST)
MMN2     = 28.0134 ;                                       % [g/mol] N2
TcN2     = 126.192 ;                                       % [K]
PcN2     = 33.958  ;                                       % [bar] 
wN2      = 0.0372  ;                                       % [] Pitzer
TbN2     = 77.355  ;                                       % [K] Normal BP
% ------------------------------------ O2 , Oxygen (NIST)
MMO2     = 31.9988 ;                                       % [g/mol] O2
TcO2     = 154.581 ;                                       % [K]
PcO2     = 50.430  ;                                       % [bar] 
wO2      = 0.0222  ;                                       % [] Pitzer
TbO2     = 90.1878 ;                                       % [K] Normal BP
% ------------------------------------ CO2 , Carbon dioxide (NIST)
MMCO2    = 44.0095 ;                                       % [g/mol] CH4
TcCO2    = 304.1282;                                       % [K]
PcCO2    = 73.773  ;                                       % [bar] 
wCO2     = 0.22394 ;                                       % [] Pitzer
TbCO2    = 194.75  ;                                       % [K] Normal BP
% ------------------------------------ H2O , Water (NIST)
MMH2O    = 18.0153 ;                                       % [g/mol] CH4
TcH2O    = 647.096 ;                                       % [K]
PcH2O    = 220.640 ;                                       % [bar] 
wH2O     = 0.3443  ;                                       % [] Pitzer
TbH2O    = 373.1243;                                       % [K] Normal BP
% ------------------------------------ C1 , CH4 , Methane (NIST)
MM1      = 16.0425 ;                                       % [g/mol] CH4
Tc1      = 190.564 ;                                       % [K]
Pc1      = 45.992  ;                                       % [bar] 
w1       = 0.01142 ;                                       % [] Pitzer
Tb1      = 111.667 ;                                       % [K] Normal BP
LHV1     = 802125  ;									   % [J/mol]
% ------------------------------------ C2 , C2H6 , Ethane (NIST)
MM2      = 30.0690 ;                                       % [g/mol] C2H6
Tc2      = 305.33  ;                                       % [K]
Pc2      = 48.718  ;                                       % [bar] 
w2       = 0.0993  ;                                       % [] Pitzer
Tb2      = 184.552 ;                                       % [K] Normal BP
LHV2     = 1431885.78 ;                                    % [J/mol]
% ------------------------------------ C3 , C3H8 , Propane (NIST)
MM3      = 44.0956 ;                                       % [g/mol] C3H8
Tc3      = 369.825 ;                                       % [K]
Pc3      = 42.4766 ;                                       % [bar]
w3       = 0.1524  ;                                       % [] Pitzer
Tb3      = 231.06  ;                                       % [K] Normal BP
LHV3     = 2043831.06 ;                                    % [J/mol]
% ------------------------------------ C4 , C4H10 , Butane (NIST)
MM4      = 58.1222 ;                                       % [g/mol] C4H10
Tc4      = 425.125 ;                                       % [K]
Pc4      = 37.960  ;                                       % [bar] 
w4       = 0.201   ;                                       % [] Pitzer
Tb4      = 272.660 ;                                       % [K] Normal BP
LHV4     = 2659090.65 ;									   % [J/mol]
% ------------------------------------ C4i , C4H10i , Isobutane (NIST)
MM4i     = 58.1222 ;                                       % [g/mol] C4H10i
Tc4i     = 407.81  ;                                       % [K]
Pc4i     = 36.290  ;                                       % [bar] 
w4i      = 0.184   ;                                       % [] Pitzer
Tb4i     = 261.401 ;                                       % [K] Normal BP
LHV4i    = 2659090.65 ;									   % [J/mol]
% ------------------------------------ C5 , C5H12 , Pentane (NIST)
MM5      = 72.1488 ;                                       % [g/mol] C5H12
Tc5      = 469.7   ;                                       % [K]
Pc5      = 33.700  ;                                       % [bar] 
w5       = 0.251   ;                                       % [] Pitzer
Tb5      = 309.21  ;                                       % [K] Normal BP
LHV5     = 3271948.08 ;									   % [J/mol]
% ------------------------------------ C5i , C5H12i , Isopentane (NIST)
MM5i     = 72.1488 ;                                       % [g/mol] C5H12i
Tc5i     = 460.35  ;                                       % [K]
Pc5i     = 33.957  ;                                       % [bar] 
w5i      = 0.2296  ;                                       % [] Pitzer
Tb5i     = 300.97  ;                                       % [K] Normal BP
LHV5i    = 3271948.08 ;									   % [J/mol]
% ------------------------------------ C6 , C6H14 , Hexane (NIST)
MM6      = 86.1754 ;                                       % [g/mol] C6H14
Tc6      = 507.82  ;                                       % [K]
Pc6      = 30.340  ;                                       % [bar] 
w6       = 0.299   ;                                       % [] Pitzer
Tb6      = 341.86  ;                                       % [K] Normal BP
% ------------------------------------ C7 , C7H16 , Heptane (NIST)
MM7      = 100.2019;                                       % [g/mol] C7H16
Tc7      = 540.13  ;                                       % [K]
Pc7      = 27.360  ;                                       % [bar] 
w7       = 0.349   ;                                       % [] Pitzer
Tb7      = 371.53  ;                                       % [K] Normal BP

% ------------------------------------ kij , Cross-coeff. 1PSRK
kN21 = 0.02780  ;kN22  = 0.04070   ;kN23  = 0.07630   ;
kN24 = 0.07000  ;kN24i = 0.09440   ;kN25i = 0.08670   ;
k12  = -0.0078  ;k13   = 0.00900   ;k14   = 0.00560   ;
k14i = 0.02410  ;k15i  = -0.00780  ;k23   = -0.00220  ;
k24  = 0.00670  ;k24i  = -0.01000  ;k25i  = 0         ;
k34  = 0        ;k34i  = -0.01000  ;k35i  = 0.00780   ;
k44i = 0.00110  ;k45i  = 0.00425   ;k4i5i = 0         ;

kN2O2=0; kN2CO2=0; kN2H2O=0; kO2CO2=0; kO2H2O=0;
kO21=0; kO22=0; kO23=0; kO24=0; kO24i=0; kO25i=0;
kCO2H2O=0; kCO21=0; kCO22=0; kCO23=0; kCO24=0;
kCO24i=0; kCO25i=0; kH2O1=0; kH2O2=0; kH2O3=0;
kH2O4=0; kH2O4i=0; kH2O5i=0;
kijs   =   [ 0      kN2O2  kN2CO2  kN2H2O   kN21  kN22  kN23  kN24   kN24i  kN25i	;
			 kN2O2  0      kO2CO2  kO2H2O   kO21  kO22  kO23  kO24   kO24i  kO25i	;
			 kN2CO2 kO2CO2 0       kCO2H2O  kCO21 kCO22 kCO23 kCO24  kCO24i kCO25i	;
			 kN2H2O kO2H2O kCO2H2O 0        kH2O1 kH2O2 kH2O3 kH2O4  kH2O4i kH2O5i	;
             kN21   kO21   kCO21   kH2O1    0     k12   k13   k14    k14i   k15i	;
             kN22   kO22   kCO22   kH2O2    k12   0     k23   k24    k24i   k25i	;
             kN23   kO23   kCO23   kH2O3    k13   k23   0     k34    k34i   k35i	;
             kN24   kO24   kCO24   kH2O4    k14   k24   k34   0      k44i   k45i	;
             kN24i  kO24i  kCO24i  kH2O4i   k14i  k24i  k34i  k44i   0      k4i5i	;
             kN25i  kO25i  kCO25i  kH2O5i   k15i  k25i  k35i  k45i   k4i5i  0		];

props         = ...
              [ TcN2 , TcO2, TcCO2, TcH2O, Tc1 , Tc2 , Tc3 , Tc4 , Tc4i , Tc5i ; % [K]
                PcN2 , PcO2, PcCO2, PcH2O, Pc1 , Pc2 , Pc3 , Pc4 , Pc4i , Pc5i ; % [bar]
                wN2  , wO2 , wCO2 , wH2O , w1  , w2  , w3  , w4  , w4i  , w5i  ;
                kijs                                                           ];% []

LHV=[LHV1 LHV2 LHV3 LHV4 LHV4i LHV5i];

Tmax=500; step=1;
ATmin=3;
Hfun={@AL_Hid_N2,@AL_Hid_O2,@AL_Hid_CO2,@AL_Hid_H2O,@AL_Hid_CH4,@AL_Hid_C2H6,@AL_Hid_C3H8,@AL_Hid_C4H10,@AL_Hid_C4H10i,@AL_Hid_C5H12i};
Sfun={@AL_Sid_N2,@AL_Sid_O2,@AL_Sid_CO2,@AL_Sid_H2O,@AL_Sid_CH4,@AL_Sid_C2H6,@AL_Sid_C3H8,@AL_Sid_C4H10,@AL_Sid_C4H10i,@AL_Sid_C5H12i};
Nelt=length(Hfun);
LHVel=length(LHV);
LHV=[zeros(1,Nelt-LHVel) LHV];
% Natural Gas
n2=0.040; o2=0; co2=0; h2o=0; c1=0.875; c2=0.055; c3=0.021; c4=0.005; c4i=0.003; c5i=0.001;
S6_zis=[n2,o2,co2,h2o,c1,c2,c3,c4,c4i,c5i];
S6_idx=S6_zis>0; S6_idx2=[true,true,true,S6_idx];
S6_zis=S6_zis(S6_idx); S6_props=props(S6_idx2,S6_idx);
S6_Hfun=Hfun(S6_idx); S6_Sfun=Sfun(S6_idx);
S6_n=0.24;
S6_T=300; S6_P=40;
S7_T=113; S7_P=S6_P;% S7_T iterates, 113 is the starting value
S8_T="Pending"; S8_P=1;% At 1 bar -> Tbub=101.211672; Tdew=196.323943;
% S10 Everything pending
%NelS10=length(S6_Hfun); Useless
S10_Tin="Pending"; S10_Pin=S8_P;
S10_Tout="Pending"; S10_Pout=20;% Pressure before combustion 15-25
% Air
n2=0.79; o2=1-n2; co2=0; h2o=0; c1=0; c2=0; c3=0; c4=0; c4i=0; c5i=0;
Air_zis=[n2,o2,co2,h2o,c1,c2,c3,c4,c4i,c5i]; Air_ratio=3.5;
Air_idx=Air_zis>0; Air_idx2=[true,true,true,Air_idx];
Air_zis=Air_zis(Air_idx); Air_props=props(Air_idx2,Air_idx);
Air_Hfun=Hfun(Air_idx); Air_Sfun=Sfun(Air_idx);
Air_Tin=300; Air_Pin=1;
Air_Tout="Pending"; Air_Pout=S10_Pout;
% Mix Everything pending
Mix_T="Pending"; Mix_P=S10_Pout;
% Flue
Flue_idx=true(1,4); Flue_idx2=true(1,7);
Flue_props=props(Flue_idx2,Flue_idx);
Flue_Hfun=Hfun(Flue_idx); Flue_Sfun=Sfun(Flue_idx);
Flue_Tin="Pending"; Flue_Pin=S10_Pout;
Flue_Tout="Pending"; Flue_Pout=S8_P;
% Refrigerant
n2=0.116; o2=0; co2=0; h2o=0; c1=0.284; c2=0.308; c3=0.14; c4=0.057; c4i=0; c5i=0.095;
Ref_zis=[n2,o2,co2,h2o,c1,c2,c3,c4,c4i,c5i];
Ref_idx=Ref_zis>0; Ref_idx2=[true,true,true,Ref_idx];
Ref_zis=Ref_zis(Ref_idx); Ref_props=props(Ref_idx2,Ref_idx);
Ref_Hfun=Hfun(Ref_idx); Ref_Sfun=Sfun(Ref_idx);
Ref_n="Pending"; NelRef=length(Ref_zis);
S3_T=305; S3_P=24;
S4_T="Pending"; S4_P=S3_P;
S5_T="Pending from S7_T"; S5_P="Pending";%3 from design table Hot_Tout>3, 4 from stream table Hot_Tout<3, 3.824378946679644 from loop
S1_T="Pending"; S1_P="Pending same as S5_P";
%Cold_P obtained from iteration that fullfills the conditions Hot_Tout_H(1)-(Cold_Tin+ATmin)  <convTtol and >=0
S2a_T="Pending"; S2a_P="Pending";
S2b_T=S3_T; S2b_P="Pending same as S2a_P";
S2_T="Pending"; S2_P=S3_P;

Comp_eff=0.8; Turb_eff=0.9;

convGCCtol = 1e-5         ;
convPtol = 1e-5          ;                                % [] tolerance for Cold_P
convTtol = 1e-10         ;                                % [] tolerance
maxiter = 200            ;                                % [] max. iteration limit
dT = 1e-10;
Nst_TvsH=100;% Number of steps to represent H vs T.
Nst_file=500;% Number of steps to save in file. Should be greater than Nst_TvsH.

S4_data=sprintf(".\\data\\S4_%fbar.dat",S4_P);
S6_data=sprintf(".\\data\\S6_%fbar.dat",S6_P);
S8_data=sprintf(".\\data\\S8_%fbar.dat",S8_P);
P_data=sprintf(".\\data\\Valv_%.1fK.dat",ATmin);
S4_data=dlmread(S4_data);
S6_data=dlmread(S6_data);
S8_data=dlmread(S8_data);
P_data=dlmread(P_data);
S5_Pmax =  3.905941327298915;
% The check for every OFs(1)<tolerance should be BEFORE the NR step.
%----------------------------Data---------------------------------
%{
S4_bd=bubbleDew(Ref_zis, Tmax, step, S4_P, Ref_props, maxiter, convTtol, dT);
S4_TvsH=rangeEnthalpy(Ref_zis, S4_bd(1,1), S4_bd(2,1), S4_bd(3,:), S4_bd(4,:), 104, S3_T, S4_P, Ref_props, maxiter, convTtol, Nst_file, dT, Ref_Hfun);
% 104K because the minimum would be S8_Tbub=101.211672 + ATmin
S4_data=sprintf("data\\S4_%fbar.dat",S4_P);
fid = fopen( S4_data , 'w+' ) ;
for( i = 1 : Nst_file )
    fprintf( fid , "%.10f %.10f\n" , S4_TvsH( i , : ) ) ;
end
fclose( fid ) ;
S6_bd=bubbleDew(S6_zis, Tmax, step, S6_P, S6_props, maxiter, convTtol, dT);
S6_TvsH=rangeEnthalpy(S6_zis, S6_bd(1,1), S6_bd(2,1), S6_bd(3,:), S6_bd(4,:), 100, S6_T, S6_P, S6_props, maxiter, convTtol, Nst_file*2, dT, S6_Hfun);
S6_data=sprintf("data\\S6_%fbar.dat",S6_P);
fid = fopen( S6_data , 'w+' ) ;
for( i = 1 : (Nst_file*2) )
		fprintf( fid , "%.10f %.10f\n" , S6_TvsH( i , : ) ) ;
end
fclose( fid ) ;
S8_bd=bubbleDew(S6_zis, Tmax, step, S8_P, S6_props, maxiter, convTtol, dT);
S8_TvsH=rangeEnthalpy(S6_zis, S8_bd(1,1), S8_bd(2,1), S8_bd(3,:), S8_bd(4,:), 101.5, 140, S8_P, S6_props, maxiter, convTtol, Nst_file, dT, S6_Hfun);
S8_data=sprintf("data\\S8_%fbar.dat",S8_P);
fid = fopen( S8_data , 'w+' ) ;
col = length(S8_TvsH(1,:));
for( i = 1 : Nst_file )
	for( j = 1 : col )
		fprintf( fid , "%.10f " , S8_TvsH( i , j ) ) ;
	end
	fprintf( fid , "\n");
end
fclose( fid ) ;
P=4;
P_data=sprintf(".\\data\\Valv_%.1fK.dat",ATmin);
S5_bd=bubbleDew(Ref_zis, Tmax, step, P, Ref_props, maxiter, convTtol, dT);
T=linspace(106,146,Nst_file*2);
fid = fopen( P_data , 'w+' ) ;
for(i=1:(Nst_file))
	for(j=1:maxiter)
		OFs=[];
		for(P=[P (P+dT)])
			S5_T_H=pointEnthalpy(Ref_zis, S5_bd(1,1), S5_bd(2,1), S5_bd(3,:), S5_bd(4,:), T(i), P, Ref_props, maxiter, convTtol, dT, Ref_Hfun);
			S4_T=interp1(S4_data(:,2),S4_data(:,1),S5_T_H(2),'cubic');
			OF=ATmin-(S4_T-T(i));
			OFs=[OFs OF];
		end	
		P=P-dT-OFs(1)/(OFs(2)-OFs(1))*dT;
		S5_bd=bubbleDew(Ref_zis, Tmax, step, P, Ref_props, maxiter, convTtol, dT);
		% This should be before to make sure OFs(1)<=0 it's true and P=P-dT; S5_bd(P);
		if(abs(OFs(1))<convPtol&&OFs(1)<=0)
			break;
		end
	end
	S5_T_H=pointEnthalpy(Ref_zis, S5_bd(1,1), S5_bd(2,1), S5_bd(3,:), S5_bd(4,:), T(i), P, Ref_props, maxiter, convTtol, dT, Ref_Hfun);
	S4_T=interp1(S4_data(:,2),S4_data(:,1),S5_T_H(2),'cubic');
	fprintf( fid , "%.12f %.12f %.12f %.12f %.12f ",T(i),S4_T,P,S5_bd(1,1),S5_bd(2,1) ) ;
	for( j = [3 4] )
		for( k = 1 : NelRef )
			fprintf( fid , "%.16f ",S5_bd(j,k) ) ;
		end
	end
	fprintf( fid , "\n");
end
fclose( fid ) ;
% To calculate the maximum pressure without condensation
%-S2a_Pmax =  9.682075803007017 --> S5_Pmax =  3.905941327298915--
P=9;
for(i=1:maxiter)
	OFs=[];
	for(P=[P (P+dT)])
		S2a_bd=bubbleDew(Ref_zis, Tmax, step, P, Ref_props, maxiter, convTtol, dT);
		OF=S2a_bd(2,1)-S2b_T;
		OFs=[OFs OF];
	end
	if(abs(OFs(1))<convTtol&&OFs(1)<=0)
		P=P-dT;
		break
	end
	P=P-dT-OFs(1)/(OFs(2)-OFs(1))*dT;
end
%}


S4_bd=bubbleDew(Ref_zis, Tmax, step, S4_P, Ref_props, maxiter, convTtol, dT);
S5_bdmax=bubbleDew(Ref_zis, Tmax, step, S5_Pmax, Ref_props, maxiter, convTtol, dT);
%-----------------------Air Compression---------------------------
%
Air_Tin_S=pointEntropyV(Air_zis, Air_Tin, Air_Pin, Air_props, Air_Sfun);
T=600;
for(i=1:maxiter)
	OFs=[];
	for(T=[T (T+dT)])
		Air_Tout_Sid=pointEntropyV(Air_zis, T, Air_Pout, Air_props, Air_Sfun);
		OF=Air_Tout_Sid(2)-Air_Tin_S(2);
		OFs=[OFs OF];
	end
	T=T-dT-OFs(1)/(OFs(2)-OFs(1))*dT;
	if(abs(OFs(1))<convTtol)
		break;
	end
end
Air_Tin_H=pointEnthalpyV(Air_zis, Air_Tin, Air_Pin, Air_props, Air_Hfun);
Air_Tout_Hid=pointEnthalpyV(Air_zis, T, Air_Pout, Air_props, Air_Hfun);
HcompAir=(Air_Tout_Hid(2)-Air_Tin_H(2))/Comp_eff;
for(i=1:maxiter)
	OFs=[];
	for(T=[T (T+dT)])
		Air_Tout_H=pointEnthalpyV(Air_zis, T, Air_Pout, Air_props, Air_Hfun);
		OF=Air_Tout_H(2)-Air_Tin_H(2)-HcompAir;
		OFs=[OFs OF];
	end
	T=T-dT-OFs(1)/(OFs(2)-OFs(1))*dT;
	if(abs(OFs(1))<convTtol)
		break;
	end
end
Air_Tout=T;
Air_Tout_H=pointEnthalpyV(Air_zis, Air_Tout, Air_Pout, Air_props, Air_Hfun);
%}

tic
preS5_P=0; Hgccmin=0;
S1_Tmax=S3_T-ATmin;
for(i=1:maxiter)
	i
	printflag=0;
	OFs=[];
	for(S7_T=[S7_T (S7_T+dT)])
		S5_T=S7_T-ATmin;
		% Stoichiometry needs to reset each loop
		O2st=[zeros(1,Nelt-LHVel) 2 3.5 5 6.5 6.5 8];
		CO2st=[zeros(1,Nelt-LHVel) 1 2 3 4 4 5];
		H2Ost=[zeros(1,Nelt-LHVel) 2 3 4 5 5 6];

		T=linspace(S6_T,S7_T,Nst_TvsH)';
		S6_TvsH=[T interp1(S6_data(:,1),S6_data(:,2),T,'cubic')];
		S6_H=S6_n*S6_TvsH(:,2);
		Hneed=S6_H(1)-S6_H(end);
		
		S8_values=interp1(S8_data(:,2),S8_data(:,[1 3:10]),S6_TvsH(end,2),'cubic');
		S8_T=S8_values(1);
		
		%------------------NG Vapor Compression-------------------
		%
		S10_zis=S8_values(3:end);
		S10_idx=S10_zis>0; S10_idx2=[true,true,true,S10_idx];
		S10_zis=S10_zis(S10_idx)/sum(S10_zis(S10_idx)); S10_props=S6_props(S10_idx2,S10_idx);
		S10_Hfun=S6_Hfun(S10_idx); S10_Sfun=S6_Sfun(S10_idx);
		S10_n=S6_n*S8_values(2);
		S10_Tin=S8_T;
		S10_Tin_S=pointEntropyV(S10_zis, S10_Tin, S10_Pin, S10_props, S10_Sfun);
		T=400;% Might need to give several Ts to proceed with continues.
		for(j=1:maxiter)
			OFs2=[];
			for(T=[T (T+dT)])
				S10_Tout_Sid=pointEntropyV(S10_zis, T, S10_Pout, S10_props, S10_Sfun);
				OF2=S10_Tout_Sid(2)-S10_Tin_S(2);
				OFs2=[OFs2 OF2];
			end
			T=T-dT-OFs2(1)/(OFs2(2)-OFs2(1))*dT;
			if(abs(OFs2(1))<convTtol)
				break;
			end
		end
		S10_Tin_H=pointEnthalpyV(S10_zis, S10_Tin, S10_Pin, S10_props, S10_Hfun);
		S10_Tout_Hid=pointEnthalpyV(S10_zis, T, S10_Pout, S10_props, S10_Hfun);
		HcompS10=(S10_Tout_Hid(2)-S10_Tin_H(2))/Comp_eff;
		for(j=1:maxiter)
			OFs2=[];
			for(T=[T (T+dT)])
				S10_Tout_H=pointEnthalpyV(S10_zis, T, S10_Pout, S10_props, S10_Hfun);
				OF2=S10_Tout_H(2)-S10_Tin_H(2)-HcompS10;
				OFs2=[OFs2 OF2];
			end
			T=T-dT-OFs2(1)/(OFs2(2)-OFs2(1))*dT;
			if(abs(OFs2(1))<convTtol)
				break;
			end
		end
		S10_Tout=T;
		S10_Tout_H=pointEnthalpyV(S10_zis, S10_Tout, S10_Pout, S10_props, S10_Hfun);
		%}
		
		%--------------------------Mix----------------------------
		%
		O2st=O2st(S6_idx)(S10_idx);
		O2st=sum(O2st.*S10_zis)*S10_n;
		O2_n=O2st*Air_ratio;
		Air_n=Air_zis(1)*O2_n/Air_zis(2);
		Mix_n=Air_n+S10_n;
		j=k=l=1; Mix_zis=zeros(1,Nelt);
		for(m=1:Nelt)
			if(Air_idx(m))
				Mix_zis(m)=Mix_zis(m)+Air_n*Air_zis(j);
				j++;
			end
			if(S6_idx(m))
				if(S10_idx(k))
					Mix_zis(m)=Mix_zis(m)+S10_n*S10_zis(l);
					l++;
				end
				k++;
			end
		end
		Mix_zis=Mix_zis/Mix_n;
		Mix_idx=Mix_zis>0; Mix_idx2=[true,true,true,Mix_idx];
		Mix_zis=Mix_zis(Mix_idx); Mix_props=props(Mix_idx2,Mix_idx);
		Mix_Hfun=Hfun(Mix_idx); Mix_Sfun=Sfun(Mix_idx);
		Hmix=Air_n*Air_Tout_H(2)-S10_n*S10_Tout_H(2);
		T=(Air_Tout+S10_Tout)/2;
		for(j=1:maxiter)
			OFs2=[];
			for(T=[T (T+dT)])
				Mix_T_H=pointEnthalpyV(Mix_zis, T, Mix_P, Mix_props, Mix_Hfun);
				OF2=Mix_n*Mix_T_H(2)-Hmix;
				OFs2=[OFs2 OF2];
			end
			T=T-dT-OFs2(1)/(OFs2(2)-OFs2(1))*dT;
			if(abs(OFs2(1))<convTtol)
				break;
			end
		end
		Mix_T=T;
		Mix_T_H=pointEnthalpyV(Mix_zis, Mix_T, Mix_P, Mix_props, Mix_Hfun);
		%}
		
		%-----------------------Combustion------------------------
		%
		LHVt=sum(LHV(S6_idx)(S10_idx).*S10_zis*S10_n);
		O2_n=O2_n-O2st; N2_n=Air_n*Air_zis(1);
		CO2_n=sum(CO2st(S6_idx)(S10_idx).*S10_zis*S10_n);
		H2O_n=sum(H2Ost(S6_idx)(S10_idx).*S10_zis*S10_n);
		Flue_zis=[N2_n O2_n CO2_n O2_n zeros(1,LHVel)];
		Flue_idx=Flue_zis>0; Flue_idx2=[true,true,true,Flue_idx];
		Flue_n=sum(Flue_zis); Flue_zis=Flue_zis(Flue_idx)/Flue_n;
		Flue_props=props(Flue_idx2,Flue_idx);
		Flue_Hfun=Hfun(Flue_idx); Flue_Sfun=Sfun(Flue_idx);
		Flue_Pin=Mix_P;

		Mix_Tr_H=pointEnthalpyV(Mix_zis, 298, 1, Mix_props, Mix_Hfun);
		Flue_Tin_H=pointEnthalpyV(Flue_zis, Mix_T, Flue_Pin, Flue_props, Flue_Hfun);
		Flue_Tr_H=pointEnthalpyV(Flue_zis, 298, 1, Flue_props, Flue_Hfun);
		
		Comb_H=Flue_Tr_H(2)*(Flue_n)+LHVt+Mix_n*(Mix_T_H(2)-Mix_Tr_H(2));
		T=Mix_T;
		for(j=1:maxiter)
			OFs2=[];
			for(T=[T (T+dT)])
				Flue_Tin_H=pointEnthalpyV(Flue_zis, T, Flue_Pin, Flue_props, Flue_Hfun);
				OF2=Flue_Tin_H(2)*(Flue_n)-Comb_H;
				OFs2=[OFs2 OF2];
			end
			T=T-dT-OFs2(1)/(OFs2(2)-OFs2(1))*dT;
			if(abs(OFs2(1))<convTtol)
				break;
			end
		end
		Flue_Tin=T;
		Flue_Tin_H=pointEnthalpyV(Flue_zis, Flue_Tin, Flue_Pin, Flue_props, Flue_Hfun);
		%}
		
		%-----------------Flue Gases Expansion--------------------
		%
		Flue_Tin_S=pointEntropyV(Flue_zis, Flue_Tin, Flue_Pin, Flue_props, Flue_Sfun);
		T=Flue_Tin;% Lower T start may be needed.
		for(j=1:maxiter)
			OFs2=[];
			for(T=[T (T+dT)])
				Flue_Tout_Sid=pointEntropyV(Flue_zis, T, Flue_Pout, Flue_props, Flue_Sfun);
				OF2=Flue_Tout_Sid(2)-Flue_Tin_S(2);
				OFs2=[OFs2 OF2];
			end
			T=T-dT-OFs2(1)/(OFs2(2)-OFs2(1))*dT;
			if(abs(OFs2(1))<convTtol)
				break;
			end
		end
		Flue_Tout_Hid=pointEnthalpyV(Flue_zis, T, Flue_Pout, Flue_props, Flue_Hfun);
		HturbFlue=Turb_eff*(Flue_Tin_H(2)-Flue_Tout_Hid(2));
		% Technically not needed
		%
		for(j=1:maxiter)
			OFs2=[];
			for(T=[T (T+dT)])
				Flue_Tout_H=pointEnthalpyV(Flue_zis, T, Flue_Pout, Flue_props, Flue_Hfun);
				OF2=Flue_Tin_H(2)-Flue_Tout_H(2)-HturbFlue;
				OFs2=[OFs2 OF2];
			end
			T=T-dT-OFs2(1)/(OFs2(2)-OFs2(1))*dT;
			if(abs(OFs2(1))<convTtol)
				break;
			end
		end
		Flue_Tout=T;
		Flue_Tout_H=pointEnthalpyV(Flue_zis, Flue_Tout, Flue_Pout, Flue_props, Flue_Hfun);
		%}
		%}
		%--------------------------S5-----------------------------
		%
		S5_P=S1_P=interp1(P_data(:,1),P_data(:,3),S5_T,'cubic');
		if(S5_P<S5_Pmax)
			S5_bd=interp1(P_data(:,1),P_data(:,4:end),S5_T,'cubic');
			S5_bd=[S5_bd(1) zeros(1,NelRef-1); S5_bd(2) zeros(1,NelRef-1); S5_bd(3:(2+NelRef)); S5_bd((3+NelRef):end)];
			S5_T_H=[S5_T interp1(P_data(:,1),P_data(:,2),S5_T,'cubic')];
			S4_T=interp1(P_data(:,1),P_data(:,2),S5_T,'cubic');
		else
			S5_P=S1_P=S5_Pmax;
			S5_bd=S5_bdmax;
			S5_T_H=pointEnthalpy(Ref_zis, S5_bd(1,1), S5_bd(2,1), S5_bd(3,:), S5_bd(4,:), S5_T, S5_P, Ref_props, maxiter, convTtol, dT, Ref_Hfun);
			for(j=1:maxiter)
				OFs2=[];
				for(S4_T=[S4_T (S4_T+dT)])
					S4_T_H=[S4_T interp1(S4_data(:,1),S4_data(:,2),S4_T,'cubic')];
					OF2=S4_T_H(2)-S5_T_H(2);
					OFs2=[OFs2 OF2];
				end
				S4_T=S4_T-dT-OFs2(1)/(OFs2(2)-OFs2(1))*dT;
				if(abs(OFs2(1))<convTtol)
					break;
				end
			end
				
		end
		if(preS5_P~=S5_P)
			S5_TvsH=rangeEnthalpy(Ref_zis, S5_bd(1,1), S5_bd(2,1), S5_bd(3,:), S5_bd(4,:), S5_T-1, S1_Tmax+1, S5_P, Ref_props, maxiter, convTtol, Nst_file, dT, Ref_Hfun);
			S5_data=S5_TvsH;
			preS5_P=S5_P;
		else
			S5_data=S5_TvsH;
		end

		S1_T_H=S5_data(end,:);
		S5_T_H=S5_data(1,:);
		%}
		
		%-----------------Minimum refrigerant---------------------
		%
		T=linspace(S3_T,S4_T,Nst_TvsH)';
		S4_TvsH=[T interp1(S4_data(:,1),S4_data(:,2),T,'cubic')];
		% Minimum refrigerant respecting only the pinch at inlet and outlet
		S4_Ht=S4_TvsH(1,2)-S4_TvsH(end,2);
		Ref_nmin=Hneed/(S1_T_H(2)-S5_T_H(2)-S4_Ht);
		% Infinite or maximum refrigerant possible
		T=(S5_T+S1_Tmax)/2;
		for(j=1:maxiter)
			OFs2=[];
			for(T=[T (T+dT)])
				S1_T_H=interp1(S5_data(:,1),S5_data(:,2),T,'cubic');
				OF2=S1_T_H-S4_TvsH(1,2);
				OFs2=[OFs2 OF2];
			end
			T=T-dT-OFs2(1)/(OFs2(2)-OFs2(1))*dT;
			if(abs(OFs2(1))<convPtol)
				break;
			end
		end
		S1_Tmin=max([T,S5_bd(2,1)]);
		% Could add a check from the GCC here although pretty pointless.
		S6_TvsH(:,1)=S6_TvsH(:,1)-ATmin/2;
		S4_TvsH(:,1)=S4_TvsH(:,1)-ATmin/2;
		% GCC calculation
		Tlow=S1_Tmin; Thigh=S1_Tmax;
		for(j=1:50)
			T=(Thigh+Tlow)/2;
			T2=linspace(T,S5_T,Nst_TvsH)';
			S1_TvsH=[T2 interp1(S5_data(:,1),S5_data(:,2),T2,'cubic')];
			S1_TvsH(:,1)=S1_TvsH(:,1)+ATmin/2;
			Ref_n=Hneed/(S1_TvsH(1,2)-S1_TvsH(end,2)-S4_Ht);
			S4_H=Ref_n*S4_TvsH(:,2);
			S1_H=Ref_n*S1_TvsH(:,2);

			idx=[Nst_TvsH Nst_TvsH Nst_TvsH];
			next_idx=idx-1;

			Tstop=S3_T-ATmin/2;
			Tend=[S1_TvsH(1,1) S4_TvsH(1,1) S6_TvsH(1,1)];
			TvsH=[];	Tgcc=S5_T+ATmin/2;	Hgccmin=0;	Hgcc=0;
			% May be possible to get rid of redundant boolean checks in the loop. Ignoring pure ref (Horizontal TvsH)
			while(Tgcc<Tstop)
				holdingT=[S1_TvsH(idx(1),1) S4_TvsH(idx(2),1) S6_TvsH(idx(3),1)];
				next_holdingT=[S1_TvsH(next_idx(1),1) S4_TvsH(next_idx(2),1) S6_TvsH(next_idx(3),1)];
				holdingH=[S1_H(idx(1)) -S4_H(idx(2)) -S6_H(idx(3))];
				next_holdingH=[S1_H(next_idx(1)) -S4_H(next_idx(2)) -S6_H(next_idx(3))];
				
				GCC_idx=(Tgcc>=holdingT)&(Tgcc<next_holdingT);
				slope=(next_holdingH(GCC_idx)-holdingH(GCC_idx))./(next_holdingT(GCC_idx)-holdingT(GCC_idx));
				
				Tgcc_idx=(Tgcc>=holdingT)&(Tgcc<=next_holdingT)&(Tgcc<Tend);
				if(any(Tgcc_idx))
					Tnext=min([next_holdingT(Tgcc_idx),holdingT(Tgcc<holdingT)]);
				end
				
				TvsH = [TvsH ; Tgcc Hgcc];
				Hgcc=Hgcc+(Tnext-Tgcc)*sum(slope);
				if(Hgcc<Hgccmin&&Tnext<Tstop)
					Hgccmin=Hgcc;
					%fprintf( "\nBROKE\n" )
					%break;
				end
		
				Tgcc=Tnext;
				
				inc_idx=(next_idx~=[1 1 1])&Tgcc==next_holdingT;
				idx=next_idx.*inc_idx+idx.*~inc_idx;
				next_idx=[idx(1)-1 idx(2)-1 idx(3)-1];
			end
			TvsH(end+1,:)=[Tnext Hgcc];
			OF2=Thigh-Tlow;
			if(OF2<convGCCtol&&Hgccmin==0)
				break;
			end
			if(Hgccmin<0)
				Thigh=(Thigh+Tlow)/2;
			else
				Tlow=(Thigh+Tlow)/2;
			end
		end
		S1_T=T;
		%}
		
		%------------------Ref 2 Compressions---------------------
		%
		% First step
		Ref_Pratio=(S3_P/S1_P)^0.5; % 0.5 for 2 steps compression
		S2a_P=S2b_P=Ref_Pratio*S1_P;
		S1_T_S=pointEntropyV(Ref_zis, S1_T, S1_P, Ref_props, Ref_Sfun);
		T=S1_T;
		for(j=1:maxiter)
			OFs2=[];
			for(T=[T (T+dT)])
				S2a_T_Sid=pointEntropyV(Ref_zis, T, S2a_P, Ref_props, Ref_Sfun);
				OF2=S2a_T_Sid(2)-S1_T_S(2);
				OFs2=[OFs2 OF2];
			end
			T=T-dT-OFs2(1)/(OFs2(2)-OFs2(1))*dT;
			if(abs(OFs2(1))<convTtol)
				break;
			end
		end
		S2a_T_Hid=pointEnthalpyV(Ref_zis, T, S2a_P, Ref_props, Ref_Hfun);
		S1_T_H=S5_data(end,:);
		HcompRef1=(S2a_T_Hid(2)-S1_TvsH(1,2))/Comp_eff;
		for(j=1:maxiter)
			OFs2=[];
			for(T=[T (T+dT)])
				S2a_T_H=pointEnthalpyV(Ref_zis, T, S2a_P, Ref_props, Ref_Hfun);
				OF2=S2a_T_H(2)-S1_TvsH(1,2)-HcompRef1;
				OFs2=[OFs2 OF2];
			end
			T=T-dT-OFs2(1)/(OFs2(2)-OFs2(1))*dT;
			if(abs(OFs2(1))<convTtol)
				break;
			end
		end
		S2a_T=T;
		% Second step
		S2b_T_S=pointEntropyV(Ref_zis, S2b_T, S2b_P, Ref_props, Ref_Sfun);
		T=S2b_T;
		for(j=1:maxiter)
			OFs2=[];
			for(T=[T (T+dT)])
				S2_T_Sid=pointEntropyV(Ref_zis, T, S2_P, Ref_props, Ref_Sfun);
				OF2=S2_T_Sid(2)-S2b_T_S(2);
				OFs2=[OFs2 OF2];
			end
			T=T-dT-OFs2(1)/(OFs2(2)-OFs2(1))*dT;
			if(abs(OFs2(1))<convTtol)
				break;
			end
		end
		S2b_T_H=pointEnthalpyV(Ref_zis, S2b_T, S2b_P, Ref_props, Ref_Hfun);
		S2_T_Hid=pointEnthalpyV(Ref_zis, T, S2_P, Ref_props, Ref_Hfun);
		HcompRef2=(S2_T_Hid(2)-S2b_T_H(2))/Comp_eff;
		for(j=1:maxiter)
			OFs2=[];
			for(T=[T (T+dT)])
				S2_T_H=pointEnthalpyV(Ref_zis, T, S2_P, Ref_props, Ref_Hfun);
				OF2=S2_T_H(2)-S2b_T_H(2)-HcompRef2;
				OFs2=[OFs2 OF2];
			end
			T=T-dT-OFs2(1)/(OFs2(2)-OFs2(1))*dT;
			if(abs(OFs2(1))<convTtol)
				break;
			end
		end
		S2_T=T;
		HcompRef=HcompRef1+HcompRef2;
		%}		
		
		HcompTotal=HcompS10*S10_n+HcompAir*Air_n+HcompRef*Ref_n;
		HturbTotal=HturbFlue*Flue_n;
		OF=HturbTotal-HcompTotal;
		OFs=[OFs OF];
		
		%------------------Output for values---------------------		
		%
		if(printflag==0&&(abs(OF)<0.000001))
			fprintf("\nGuess who is back, back again S7_T=%f\n",S7_T);

			figure(1);
			title('Grand Composite Curve');
			xlabel('H [J]');
			ylabel('T [K]');
			line(TvsH(:,2),TvsH(:,1))
			axis ([0 max(TvsH(:,2))])
			
			Cold=[S1_TvsH(:,1)-ATmin/2,S1_H-S1_H(end)];
			
			something=S6_H(1)-S6_H(end)
			something2=S4_H(1)-S4_H(end)
			something3=S1_H(1)-S1_H(end)
			
			idx=[Nst_TvsH Nst_TvsH]
			next_idx=idx-1;
			Tstop=S3_T-ATmin/2;
			Tend=[S4_TvsH(1,1) S6_TvsH(1,1)]
			Hot=[];	Tcc=S7_T-ATmin/2;	Hcc=0;
			while(Tcc<Tstop)
				holdingT=[S4_TvsH(idx(1),1) S6_TvsH(idx(2),1)];
				next_holdingT=[S4_TvsH(next_idx(1),1) S6_TvsH(next_idx(2),1)];
				holdingH=[S4_H(idx(1)) S6_H(idx(2))];
				next_holdingH=[S4_H(next_idx(1)) S6_H(next_idx(2))];
				
				CC_idx=(Tcc>=holdingT)&(Tcc<next_holdingT);
				slope=(next_holdingH(CC_idx)-holdingH(CC_idx))./(next_holdingT(CC_idx)-holdingT(CC_idx));
				
				Tcc_idx=(Tcc>=holdingT)&(Tcc<=next_holdingT)&(Tcc<Tend);
				if(any(Tcc_idx))
					Tnext=min([next_holdingT(Tcc_idx),holdingT(Tcc<holdingT)]);
				end
				
				Hot = [Hot ; Tcc Hcc];
				Hcc=Hcc+(Tnext-Tcc)*sum(slope);
				
				Tcc=Tnext;
				
				inc_idx=(next_idx~=[1 1])&Tcc==next_holdingT;
				idx=next_idx.*inc_idx+idx.*~inc_idx;
				next_idx=[idx(1)-1 idx(2)-1];
			end
			Hot(end+1,:)=[Tnext Hcc];
			Hot=[Hot(:,1)+ATmin/2 Hot(:,2)];
			figure(2);
			title('Composite Curves');
			xlabel('H [J]');
			ylabel('T [K]');
			line(Cold(:,2),Cold(:,1),'linestyle','-','linewidth',1,'color','b'); 
			line(Hot(:,2),Hot(:,1),'linestyle','-','linewidth',1,'color','r');
			legend('Cold CC','Hot CC')
			
			Cold_Ref=[T2 interp1(S5_data(:,1),S5_data(:,2),T2,'cubic')];
			Cold_Ref(:,2)=Cold_Ref(:,2)-Cold_Ref(end,2);
			T=linspace(S3_T,S4_T,Nst_TvsH)';
			Hot_Ref=[T interp1(S4_data(:,1),S4_data(:,2),T,'cubic')];
			Hot_Ref(:,2)=Hot_Ref(:,2)-Hot_Ref(end,2);
			T=linspace(S6_T,S7_T,Nst_TvsH)';
			NG=[T interp1(S6_data(:,1),S6_data(:,2),T,'cubic')];
			NG(:,2)=NG(:,2)-NG(end,2);
			figure(3);
			title('Specific Enthalpy Curves');
			xlabel('h [J/mol]');
			ylabel('T [K]');
			line(Cold_Ref(:,2),Cold_Ref(:,1),'linestyle','-','linewidth',1,'color','b');
			line(Hot_Ref(:,2),Hot_Ref(:,1),'linestyle','-','linewidth',1,'color','r');
			line(NG(:,2),NG(:,1),'linestyle','-','linewidth',1,'color','g');
			legend('Cold Ref','Hot Ref','NG')
			
			S9_n=S6_n*(1-S8_values(2));
			S9_zis=S6_n.*S6_zis-S10_n.*(S8_values(3:end)/sum(S8_values(3:end)));
			S9_zis=S9_zis./sum(S9_zis);
			
			fprintf("\n1 T bar: %f %f\n",S1_T,S1_P);
			fprintf("\n2a T bar: %f %f\n",S2a_T,S2a_P);
			fprintf("\n2 T bar: %f %f\n",S2_T,S2_P);
			fprintf("\n3 bV (change code first): pointEnthalpy(Ref_zis, S4_bd(1,1), S4_bd(2,1), S4_bd(3,:), S4_bd(4,:), %.16f, %.16f, Ref_props, maxiter, convTtol, dT, Ref_Hfun)\n",S3_T,S3_P);
			fprintf("\n4 T: %f\n",S4_T);
			fprintf("\n5 T bV (change code first): %f pointEnthalpy(Ref_zis, S5_bd(1,1), S5_bd(2,1), S5_bd(3,:), S5_bd(4,:), %.16f, %.16f, Ref_props, maxiter, convTtol, dT, Ref_Hfun)\n",S5_T,S5_T,S5_P);
			fprintf("\nIn tha hood Ref_n: %.16f\n",Ref_n);
			fprintf("\n8 T bV: %f %f\n",S8_T,S8_values(2));
			fprintf("\n9 n zis: %f ",S9_n);
			for(j=1:length(S6_zis))
				fprintf("%f ",S9_zis(j));
			end
			fprintf("\n\n10 n zis: %f ",S10_n);
			for(j=1:length(S10_zis))
				fprintf("%f ",S10_zis(j));
			end
			fprintf("\n\n11 T: %f\n",S10_Tout);
			fprintf("\n12 n: %f\n",Air_n);
			fprintf("\n13 T: %f\n",Air_Tout);
			fprintf("\n14 T n zis: %f %f ",Mix_T,Mix_n);
			for(j=1:length(Mix_zis))
				fprintf("%f ",Mix_zis(j));
			end
			fprintf("\n\n15 T zis: %f %f ",Flue_Tin,Flue_n);
			for(j=1:length(Flue_zis))
				fprintf("%f ",Flue_zis(j));
			end
			fprintf("\n\n16 T: %f\n",Flue_Tout);
			fprintf("\nCompressors: Air=%f Vapor=%f Ref1=%f Ref2=%f\n",HcompAir*Air_n,HcompS10*S10_n,HcompRef1*Ref_n,HcompRef2*Ref_n);
			fprintf("\nTurbine: Flue=%f\n",HturbFlue*Flue_n);
		end
		printflag=1;
		%}
		
	end

	%figure(i)
	%plot(TvsH(:,2),TvsH(:,1))
	%axis ([0 max(TvsH(:,2)) TvsH(1,1) TvsH(end,1)])
	if(abs(OFs(1))<0.000001)
		break;
	end
	S7_T=S7_T-dT-OFs(1)/(OFs(2)-OFs(1))*dT;
end
toc
%{
fprintf("\nRef_n=%.16f\n",Ref_n);
fprintf("\nS7_T=%f\n",S7_T);
fprintf("\nVapor fraction bV=%f\n",S8_values(2));
fprintf("\nAir_Tin=%f Air_Tout=%f\n",Air_Tin,Air_Tout);
fprintf("\nS10_Tin=%f S10_Tout=%f\n",S10_Tin,S10_Tout);
fprintf("\nMix_T=%f\n",Mix_T);
fprintf("\nFlue_Tin=%f Flue_Tout=%f\n",Flue_Tin,Flue_Tout);
fprintf("\nCompressors: Air=%f Vapor=%f Ref=%f\n",HcompAir*Air_n,HcompS10*S10_n,HcompRef*Ref_n);
fprintf("\nTurbine: Flue=%f\n",HturbFlue*Flue_n);
fprintf("\nNet power: W=%f\n",OF);
%plot(TvsH(:,2),TvsH(:,1))
%axis ([0 max(TvsH(:,2)) TvsH(1,1) TvsH(end,1)])