function THpoint = pointEnthalpyV(zis, Tp, P, props, Hfun)
% ========================================================================= Specifications
alphafun = "SRK"    ;
mixrule  = "Virial" ;
Nel=length(zis);
% =========================================================================== Calculations
%fprintf( "\n========================== T > DEWT\n" ) ;
params   = SRK_mix_parameters_kij( Tp , P , zis , props , alphafun, mixrule ) ;
Zs       = SRK_compress_factors( params )                                    ;
Hres     = SRK_Hres( Tp , params , Zs(1) )      ;       % [J/mol]
dHid = 0;
for(k=1:Nel)
	dHid=dHid+zis(k)*Hfun{k}(Tp);
end
THpoint    = [ Tp (dHid - Hres) ]                ;       % [J/mol]
end