function TSpoint = pointEntropyV(zis, Tp, P, props, Sfun)
% ========================================================================= Specifications
alphafun = "SRK"    ;
mixrule  = "Virial" ;
Nel=length(zis);
R=8.3144598;
% =========================================================================== Calculations
%fprintf( "\n========================== T > DEWT\n" ) ;
yis      = zis               ;                           % [mol.frac.]
params   = SRK_mix_parameters_kij( Tp , P , yis , props , alphafun, mixrule ) ;
Zs       = SRK_compress_factors( params )                                    ;
Sres     = SRK_Sres( Tp , params , Zs(1) )      ;       % [J/mol]
dSid = 0;
for(k=1:Nel)
	dSid=dSid+zis(k)*Sfun{k}(Tp);
end
TSpoint    = [ Tp (dSid - R*log(P) - Sres) ]    ;       % [J/mol]
end