function TvsHs = rangeEnthalpy(zis, Tbub, Tdew, ybubs, xdews, Tin, Tout, P, props, maxiter, convTtol, Nst, dT, Hfun)
	% ========================================================================= Specifications
	alphafun = "SRK"    ;
	mixrule  = "Virial" ;
	Nel = length(zis);
	% =========================================================================== Calculations
	% Possible error if "Nst*(Tdif)/Trange" equals a natural number. Seems unlikely so not checking.
	Thigh=max(Tin,Tout);
	Tlow=min(Tin,Tout);
	Trange = Thigh-Tlow;
	if(Tlow>=Tdew)
		nptsv=Nst;
	elseif(Thigh>=Tdew&&Tlow<Tdew&&Tlow>Tbub)
		nptsv=max(ceil(Nst*(Thigh-Tdew)/Trange)-1,1);
		nptslv=Nst-nptsv;
	elseif(Thigh>=Tbub&&Tlow<=Tdew)
		nptsv=max(ceil(Nst*(Thigh-Tdew)/Trange)-1,1);
		nptsl=max(ceil(Nst*(Tbub-Tlow)/Trange)-1,1);
		nptslv=Nst-nptsv-nptsl;
	elseif(Thigh<Tdew&&Tlow>Tbub)
		nptslv=Nst;
	elseif(Thigh<Tdew&&Thigh>Tbub&&Tlow<=Tbub)
		nptsl=max(ceil(Nst*(Tbub-Tlow)/Trange)-1,1);
		nptslv=Nst-nptsl;
	else
		nptsl=Nst;
	end

	% =========================================================================== Calculations

	TvsHsv   = [ ]   ;
	TvsHsl   = [ ]   ;
	TvsHslv  = [ ]   ;
	

	if(Thigh>=Tdew)
		%fprintf( "\n========================== Thigh => DEWT\n" ) ;
		yis      = zis ;                                         % [mol.frac.]
		
		if(nptsv==1)
			Tmin=Thigh;
			incT=1;
		else
			if(Tlow>=Tdew)
				Tmin=Tlow;
			else
				Tmin=Tdew;
			end
			nptsv=nptsv-1;
			incT     = ( Tmin - Thigh )/nptsv       ;
		end

		for( T = Thigh : incT : Tmin )

			params   = SRK_mix_parameters_kij( T , P , yis , props , alphafun, mixrule ) ;
			Zs       = SRK_compress_factors( params )                                    ;
			Hres     = SRK_Hres( T , params , Zs(1) )      ;       % [J/mol]

			dHid = 0;
			for(k=1:Nel)
				dHid=dHid+zis(k)*Hfun{k}(T);
			end
			
			dHmol    = dHid - Hres                 ;       % [J/mol]
			TvsHsv   = [ TvsHsv ; [ T dHmol ] ]            ;

		end
	end
	
	if(Tlow<=Tbub)
		%fprintf( "\n========================== BUBT => Tlow\n" ) ;
		xis      = zis               ;                           % [mol.frac.]
		
		if(nptsl==1)
			Tmax=Tlow;
			incT=1;
		else
			if(Thigh<=Tbub)
				Tmax=Thigh;
			else
				Tmax=Tbub;
			end
			nptsl=nptsl-1;
			incT     = ( Tlow - Tmax )/nptsl       ;
		end

		for( T = Tmax : incT : Tlow )

			params   = SRK_mix_parameters_kij( T , P , xis , props , alphafun, mixrule ) ;
			Zs       = SRK_compress_factors( params )                                    ;
			Hres     = SRK_Hres( T , params , Zs(2) )      ;       % [J/mol]

			dHid = 0;
			for(k=1:Nel)
				dHid=dHid+zis(k)*Hfun{k}(T);
			end
			
			dHmol    = dHid - Hres                 ;       % [J/mol]
			TvsHsl   = [ TvsHsl ; [ T dHmol ] ]            ;
			
		end
	end
	
	if(Thigh>Tbub&&Tlow<Tdew&&nptslv>0)
		%fprintf( "\n========================== DEWT => BUBT\n" ) ;
		bV       = 1        ;                                      % [] vapor fraction
		yis      = zis      ;                                      % [mol.frac.]
		xis      = xdews    ;                                      % [mol.frac.]
		Kis      = yis./xis ;                                      % [ ] init
		prevKis  = Kis      ;                                      % []
		flagT    = 0		;
		flagNp   = 0		;
		nptslv2  = 4		;% Increase the number in case this is not working. 3 seems the minimum
		
		Tmax=Tdew;
		if(nptslv==1)
			%1
			flagNp=1;
			if(Thigh<Tdew)
			%1
				Tmin=Thigh;
			elseif(Tlow>Tbub)
			%2
				Tmin=Tlow;
			else
			%3
				Tmin=(Tdew+Tbub)/2;
			end
			incT=(Tmin-Tdew)/nptslv2;
			T=[Tdew+incT:incT:Tmin];
		else
		%2
			if(Thigh>=Tdew&&Tlow<=Tbub)
			%1
				incT=(Tbub-Tdew)/(nptslv+1);
				T=[Tdew+incT:incT:Tbub-incT];
			elseif(Thigh>=Tdew&&Tlow>Tbub)
			%2
				incT=(Tlow-Tdew)/(nptslv);
				T=[Tdew+incT:incT:Tlow];
			elseif(Thigh<Tdew&&Tlow>Tbub)
			%3
				flagT=1;
				incT=(Thigh-Tdew)/nptslv2;
				incT2=(Tlow-Thigh)/(nptslv+1);
				T=[Tdew+incT:incT:Thigh Thigh+incT2:incT2:Tlow];
			else %(Thigh<Tdew&&Tlow<=Tbub)
			%4
				flagT=1;
				incT=(Thigh-Tdew)/nptslv2;
				incT2=(Tbub-Thigh)/(nptslv+1);
				T=[Tdew+incT:incT:Thigh Thigh+incT2:incT2:Tbub-incT2];
			end
		end
		T2=T; % Can do for(T=T) directly
		for( T = T2 ) %Tdew + incT : incT : Tbub - incT 
			
			for( k = 1 : maxiter )
				
				for( j = 1 : maxiter )

					% ----------------------------------- Newton-Raphson iteration
					OFs = [ ] ;                                    % [] then [OF] then [OF incOF]
					for( bV = [ bV  ( bV + dT ) ] )                % 2 rounds, OF and incOF

						OF = sum( zis.*( Kis - 1 )./( 1 + bV*( Kis - 1 ) ) ) ; % [] Obj. Func.
						OFs   = [ OFs OF ] ;                       % [OF] then [OF incOF]
						
					end
					bV  = bV - dT - OFs( 1 )/( OFs( 2 ) - OFs( 1 ) )*dT ; % [K]
					if( abs( OFs( 1 ) ) < convTtol )
						break ;
					end

				end
				assert( j < maxiter , "\n----- Error: max. iterations reached" ) ;
				
				xis      = zis./( 1 + bV*( Kis - 1 ) ) ;         % [mol.frac]
				yis      = xis.*Kis                      ;         % [mol.frac]

				% ---------------------------------------------------- Soave-improving Kis
				paramsl = SRK_mix_parameters_kij( T , P , xis , props , 'SRK', 'Virial') ;
				Zl      = SRK_compress_factors( paramsl )(2)          ; % []
				phisl   = SRK_parc_fug_coef_all( xis , paramsl , Zl ) ; % []
				
				paramsv = SRK_mix_parameters_kij( T , P , yis , props , 'SRK', 'Virial') ;
				Zv      = SRK_compress_factors( paramsv )(1)          ; % []
				phisv   = SRK_parc_fug_coef_all( yis , paramsv , Zv ) ; % []
				
				fugsv  = phisv.*yis   ;                            % []
				fugsl  = phisl.*xis   ;                            % []
				Kis    = phisl./phisv ;                            % []

				errKis = sum( abs( Kis - prevKis ) ) ;             % []
				if( errKis < convTtol )
					break ;
				end
				prevKis = Kis                        ;             % []
			end
			assert( k < maxiter , "Max. number of iterations reached (state flash)" ) ;
			assert( abs( sum(xis) - 1 ) < 1e-8 , "sum(xis) - 1 > 1e-8" )              ; 
			assert( abs( sum(yis) - 1 ) < 1e-8 , "sum(yis) - 1 > 1e-8" )              ; 
			errFug = sum( ( fugsl./fugsv .- 1 ).^2 )                                  ;
			assert( errFug < 1e-12 , "sum( ( fugsl./fugsv .- 1 ).^2 )  > 1e-12" )     ;      

			Hresl    = SRK_Hres( T , paramsl , Zl )        ;       % [J/mol]
			Hresv    = SRK_Hres( T , paramsv , Zv )        ;       % [J/mol]
			Hres     = ( 1 - bV )*Hresl + bV*Hresv         ;       % [J/mol]
			
			dHid = 0;
			for(k=1:Nel)
				dHid=dHid+zis(k)*Hfun{k}(T);
			end
			
			dHmol    = dHid - Hres ;                       % [J/mol]
			
			if(flagT==0&&flagNp==0)
				TvsHslv  = [ TvsHslv ; [ T dHmol ] ] ;
			elseif(flagNp==1)
				if(T==Thigh||T==Tlow||((Tlow<=Tbub)&&(Thigh>=Tbub)&&(T==(Tdew+Tbub)/2)))
					TvsHslv  = [ TvsHslv ; [ T dHmol ] ] ;
				end
			else %flagT==1
				if(Thigh>=T)
					TvsHslv  = [ TvsHslv ; [ T dHmol ] ] ;
				end
			end
				
		end
	end	
	
	TvsHs    = [ TvsHsv ; TvsHslv ; TvsHsl ] ;
%{
	figure( 1 ) ;
	clf ;
	t = title( 'NG COOLING' ,'fontsize', 20 ) ;
	%set ( t , "fontsize" , 20 );
	line( TvsHs( : , 2 ) , TvsHs( : , 1 ) ,...
		'Color' , 'black' ,'Marker' , 'o' ) ;
	xlabel('Enthalpy change (J/mol)' ,'fontsize', 20)
	ylabel('T (K)' , 'fontsize' , 20)
	xlim( [ TvsHs(end,2) TvsHs(1,2) ] ) ;
	%grid on ;

	fprintf( "\n========================== Thigh => DEWT\n" ) ;
	fprintf( "   T(K)      dH(J/mol)\n" ) ;
	fprintf( "-----------------------\n" ) ;

	%length( TvsHsv( k , : ) )
	for( k = 1 : nptsv + 1)
		fprintf( "%8.5f %12.3f\n" , TvsHsv( k , : ) ) ;
	end

	fprintf( "========================== DEWT => BUBT\n" ) ;
	for( k = 1 : nptslv )
		fprintf( "%8.5f %12.3f\n" , TvsHslv( k , : ) ) ;
	end


	fprintf( "========================== DEWT => Tlow\n" ) ;
	for( k = 1 : nptsl + 1)
		fprintf( "%8.5f %12.3f\n" , TvsHsl( k , : ) ) ;
	end

	fprintf( "\n\n========================== Thigh => DEWT\n" ) ;
	fprintf( "   T(K)      dH(J/mol)\n" ) ;
	fprintf( "-----------------------\n" ) ;
	for( k = 1 : nptsv + nptslv + nptsl + 2 )
		fprintf( "%8.5f %12.3f\n" , TvsHs( k , : ) ) ;
	end

	fprintf('\n\n') ;
%}
end
